function [outputImg] = aliasingDet(inputImg, detectors, projectors, filter)
% Funkce aliasingDet provede vypocet aliasing artefaktu
% 
% outputImg = aliasingDet(inputImg, detectors, projectors, filter)
% 
% Vstupni promenne:
%       inputImg   - model scena
%       projector  - pocet projektoru
%       detectors  - pocet detektoru
%       filter     - filtr pro inverzni transformaci
% 
% Vystupni promenne:
%       outputImg  - vystupni obrazek s artefaktem


        [yImg, xImg, mImg] = size(inputImg);
        if yImg > 0 && xImg > 0

            h = waitbar(0,'Probh vpoet...');
%             theta = 0:0.5:179;
            [R,xp] = radon(inputImg, projectors, detectors);
            
            waitbar(1/2);
            outputImg = iradon(R, projectors, filter);
            
            waitbar(2 / 2);
            close(h);
        
        else
            return;
        end 

end

