function [outputImg] = aliasingPro(inputImg, detectors, projectors, filter)
% Funkce aliasingPro provede vypocet aliasing artefaktu
% 
% outputImg = aliasingPro(inputImg, detectors, projectors, filter)
% 
% Vstupni promenne:
%       inputImg   - model scena
%       projector  - pocet projektoru
%       detectors  - pocet detektoru
%       filter     - filtr pro inverzni transformaci
% 
% Vystupni promenne:
%       outputImg  - vystupni obrazek s artefaktem


        [yImg, xImg, mImg] = size(inputImg);
        if yImg > 0 && xImg > 0

           
            h = waitbar(0,'Probh vpoet...');
%             theta = linspace(0,179,projekce);
            [R,xp] = radon(inputImg, projectors, detectors);
            waitbar(1 / 2);   
            
            outputImg = iradon(R, projectors, filter);
            waitbar(2 / 2);
            close(h)
        
        else
            return;
        end 

end

