function [outputImg, metalImg] = Metal(inputImg, projectors, detectors, filter)
% Funkce Metal provede vypocet kovovy artefaktu
% 
% [outputImg, metalImg] = Metal(inputImg, projectors, detectors, filter)
% 
% Vstupni promenne:
%       inputImg   - model scena
%       projector  - pocet projektoru
%       detectors  - pocet detektoru
%       filter     - filtr pro inverzni transformaci
% 
% Vystupni promenne:
%       outputImg  - vystupni obrazek s artefaktem
%       metalImg   - obrazek se zvolenym kovem

metalImg = -1;
fName = '0';
pName = '0';
[fName,pName] = uigetfile({'*.jpg;*.tif;*.png;*.gif','All Image Files';...
          '*.*','All Files' },'Open image',...
          pwd);

[ysize, xsize, map] = size(fName);
if ((fName(1,1) == 0) || (pName(1,1) == 0) && (xsize == 1))
    outputImg = -1;
    return;
end
fullName = sprintf('%s%s',pName,fName);

metalImg = double(imread(fullName))./255;
[ysize, xsize, map] = size(metalImg);
[ysize2, xsize2, map2] = size(inputImg);

if((ysize~=ysize2) && (xsize~=xsize2))
    outputImg = -1;
    errordlg('Rozmry obrzk se neshoduj','Chyba');
    return;
end


h = waitbar(0,'Probh vpoet...');

        

[R,xp] = GetRadon(inputImg, projectors, detectors);
[Rkov,xpkov] = GetRadon(metalImg, projectors, detectors);

[yR, xR] = size(R);

waitbar(1 / (xR+3));


r2 = zeros(yR, xR);
waitbar(2 / (xR+3));

for i=1:1:xR
    for j=1:1:yR
       if Rkov(j, i) > 0
           r2(j,i) = 1.05.*max(max(R));
       else
           r2(j,i) = R(j,i);
       end
    end
    waitbar(i / (xR+3));
end

outputImg = GetIRadon(r2, projectors, filter);
% outputImg = iradon(r2, theta);
waitbar(1);
close(h);

% outputImg = outputImg./maximum;


