function varargout = simulator(varargin)
% SIMULATOR M-file for simulator.fig
%      SIMULATOR, by itself, creates a new SIMULATOR or raises the existing
%      singleton*.
%
%      H = SIMULATOR returns the handle to a new SIMULATOR or the handle to
%      the existing singleton*.
%
%      SIMULATOR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SIMULATOR.M with the given input arguments.
%
%      SIMULATOR('Property','Value',...) creates a new SIMULATOR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before simulator_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to simulator_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help simulator

% Last Modified by GUIDE v2.5 19-Apr-2011 20:09:37

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @simulator_OpeningFcn, ...
                   'gui_OutputFcn',  @simulator_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
warning off;


% --- Executes just before simulator is made visible.
function simulator_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to simulator (see VARARGIN)

% Choose default command line output for simulator
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

Paths();

% declaration of global variables
global imgIsOpen;
imgIsOpen = 0;


% UIWAIT makes simulator wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = simulator_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --------------------------------------------------------------------
function tFile_Callback(hObject, eventdata, handles)
% hObject    handle to tFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


%% otevreni obrazku
function tOpen_Callback(hObject, eventdata, handles)
% hObject    handle to tOpen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
FileName = '0';
PathName = '0';
[FileName,PathName] = uigetfile({'*.jpg;*.tif;*.png;*.gif','All Image Files';...
          '*.*','All Files' },'Open image',...
          pwd);

[ysize, xsize, map] = size(FileName);
if ((FileName(1,1) == 0) || (PathName(1,1) == 0) && (xsize == 1))
    return;
end
fullName = sprintf('%s%s',PathName,FileName);
global inputImage;
global imgIsOpen;
inputImage = double(imread(fullName))./255;
imgIsOpen = 1;

axes(handles.axes1)
imshow(inputImage,[]);
freezeColors;

tmpImg = 240.*ones(255,255,3)./255;
axes(handles.axes5)
imshow(tmpImg,[0 1]);
freezeColors;

axes(handles.axes2)
imshow(tmpImg,[0 1]);
freezeColors;

axes(handles.axes3)
imshow(tmpImg,[0 1]);
freezeColors;

global bezImg;
global ArtefaktImg;
global PorovnaniImg;
bezImg = 0;
ArtefaktImg = 0;
PorovnaniImg = 0;


global setDetectors;
global setProjectors;
global setFilter;
setDetectors = 0;
setProjectors = 0;
setFilter = 0;


set(handles.tRing,'Enable','of')
set(handles.tMotion,'Enable','of')
set(handles.tAliasing,'Enable','of')
set(handles.tKovovy,'Enable','of')
set(handles.tKvantovy,'Enable','of')



%% akvizicni parametry
% --------------------------------------------------------------------
function tAkvizicni_Callback(hObject, eventdata, handles)
% hObject    handle to tAkvizicni (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global setDetectors;
global setProjectors;
global setFilter;

[setDetectors, tmpP, tmpV] = aquireT;

switch tmpV   
    case 1
        setFilter = 'Ram-Lak';
    case 2
        setFilter = 'Shepp-Logan';
    case 3
        setFilter = 'Cosine';
    case 4
        setFilter = 'Hamming';
    case 5
        setFilter = 'Hann';
    case 6
        setFilter = 'None';
    otherwise
        setFilter = 0;
end



global inputImage;
global imgIsOpen;
global bezImg;

if imgIsOpen == 1
    [ysize, xsize,map] = size(inputImage);
    if map > 1
       i2 = double(rgb2gray(inputImage))./255;
    else
        i2 = inputImage;
    end
    
    setProjectors = linspace(0, 179, tmpP);
    
    [bezFwd, xp] = GetRadon(i2, setProjectors, setDetectors);
    bezBwd = GetIRadon(bezFwd, setProjectors, setFilter);
    
    axes(handles.axes5)
    imshow(bezBwd,[]);
    freezeColors;
    bezImg = bezBwd;
    
    
    set(handles.tRing,'Enable','on')
    set(handles.tMotion,'Enable','on')
    set(handles.tAliasing,'Enable','on')
    set(handles.tKovovy,'Enable','on')
    set(handles.tKvantovy,'Enable','on')
    
end
    
% ulozeni artefaktu    
% --------------------------------------------------------------------
function tSaveAs_Callback(hObject, eventdata, handles)
% hObject    handle to tSaveAs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function tUArtefakt_Callback(hObject, eventdata, handles)
% hObject    handle to tUArtefakt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global ArtefaktImg;

FileName = '0';
PathName = '0';
[FileName,PathName] = uiputfile('*.png','Uloit artefakt');

[ysize, xsize, map] = size(FileName);
if ((FileName(1,1) == 0) || (PathName(1,1) == 0) && (xsize == 1))
    return;
end
fullName = sprintf('%s%s',PathName,FileName);

saveImg(ArtefaktImg./max(max(ArtefaktImg)),fullName);

% --------------------------------------------------------------------
function tUPorovnani_Callback(hObject, eventdata, handles)
% hObject    handle to tUPorovnani (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global PorovnaniImg;

FileName = '0';
PathName = '0';
[FileName,PathName] = uiputfile('*.png','Uloit porovnn');

[ysize, xsize, map] = size(FileName);
if ((FileName(1,1) == 0) || (PathName(1,1) == 0) && (xsize == 1))
    return;
end
fullName = sprintf('%s%s',PathName,FileName);

saveImg(PorovnaniImg./max(max(PorovnaniImg)),fullName);


% --------------------------------------------------------------------
function tExit_Callback(hObject, eventdata, handles)
% hObject    handle to tExit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
exit;

% --------------------------------------------------------------------
function tArtifact_Callback(hObject, eventdata, handles)
% hObject    handle to tArtifact (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


%% RIng artifact
% --------------------------------------------------------------------
function tRing_Callback(hObject, eventdata, handles)
% hObject    handle to tRing (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function tARAutomatic_Callback(hObject, eventdata, handles)
% hObject    handle to tARAutomatic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global inputImage;
global imgIsOpen;
global out;
global ArtefaktImg;
global PorovnaniImg;

global bezImg;
global setDetectors;
global setProjectors;
global setFilter;


in_dlg_title = 'Parametry automatickho volen kruhovho artefaktu';
prompt{1} = 'Zmna SNR u potu detektor: ';
prompt{2} = 'Volba SNR: ';
parameters = inputdlg(prompt, in_dlg_title, [1 15], {'50' '35'});

[ysize, xsize,map] = size(parameters);
if (ysize == 0) || (xsize == 0)
    return;
end

if str2double(parameters{1}) > setDetectors
   errordlg('Poet mnnch detektor neme bt vy ne poet detektor nastavench jako akvizin parametr','Chyba');
   return;
end

if imgIsOpen == 1
    [ysize, xsize,map] = size(inputImage);
    if map > 1
       i2 = double(rgb2gray(inputImage))./255;
    else
        i2 = inputImage;
    end
    out = Ring(i2, str2double(parameters{2}), str2double(parameters{1}), setProjectors, setDetectors, setFilter, 0);
    
    [yImg, xImg, mImg] = size(out);
    if yImg > 0 && xImg > 0
        axes(handles.axes2)
        imshow(out./max(max(bezImg)));
        freezeColors;
        ArtefaktImg = out;

        if mImg > 1
            I = rgb2gray(out);
        else
           I = out;
        end
        
        axes(handles.axes3)
        [yy1, xx1, map] = size(bezImg);
        [yy2, xx2, map] = size(out);
        yy = min([yy1 yy2]);
        xx = min([xx1 xx2]);
        
        bezImgRes = imresize(bezImg, [yy xx])./(max(max(bezImg)));
        outRes = imresize(out, [yy xx])./(max(max(bezImg)));

        img_diff = abs(bezImgRes - outRes);
        imshow(img_diff,[]);

        PorovnaniImg = img_diff;
    end 
end

% --------------------------------------------------------------------
function tARManual_Callback(hObject, eventdata, handles)
% hObject    handle to tARManual (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global inputImage;
global imgIsOpen;
global out;
global ArtefaktImg;
global PorovnaniImg;

global bezImg;
global setDetectors;
global setProjectors;
global setFilter;

[a, b, c] = ringT;
if ~strcmp(a, 'OK')
    return;
end

if b > setDetectors
   errordlg('Poet mnnch detektor neme bt vy ne poet detektor nastavench jako akvizin parametr','Chyba');
   return;
end

if imgIsOpen == 1
    [ysize, xsize,map] = size(inputImage);
    if map > 1
       i2 = double(rgb2gray(inputImage))./255;
    else
        i2 = inputImage;
    end
    out = Ring(i2, c, b, setProjectors, setDetectors, setFilter, -1);
    
    [yImg, xImg, mImg] = size(out);
    if yImg > 0 && xImg > 0
        axes(handles.axes2)
        imshow(out./max(max(bezImg)));
        freezeColors;
        ArtefaktImg = out;
        
        if mImg > 1
            I = rgb2gray(out);
        else
           I = out;
        end
        
        axes(handles.axes3)
        [yy1, xx1, map] = size(bezImg);
        [yy2, xx2, map] = size(out);
        yy = min([yy1 yy2]);
        xx = min([xx1 xx2]);
        
        bezImgRes = imresize(bezImg, [yy xx])./(max(max(bezImg)));
        outRes = imresize(out, [yy xx])./(max(max(bezImg)));
        
        img_diff = abs(bezImgRes - outRes);
        imshow(img_diff,[]);

        PorovnaniImg = img_diff;
    end 
end


%% Motion artifact
% --------------------------------------------------------------------
function tMotion_Callback(hObject, eventdata, handles)
% hObject    handle to tMotion (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global inputImage;
global imgIsOpen;
global ArtefaktImg;
global PorovnaniImg;

global setDetectors;
global setProjectors;
global setFilter;

global bezImg;
global tester;

tester = -1;

if imgIsOpen  == 1
    [start, stop, amp, frq, cls] = motionT;

    if cls == -1
        return;
    end
    
    [ysize, xsize,map] = size(inputImage);
    if map > 1
       i2 = double(rgb2gray(inputImage))./255;
    else
        i2 = inputImage;
    end

    out = motion(i2, start, stop, amp, frq, setProjectors, setDetectors, setFilter);

    axes(handles.axes2)
    imshow(out./max(max(bezImg)));
    freezeColors;
    ArtefaktImg = out;

    axes(handles.axes3)
    [yy1, xx1, map] = size(bezImg);
    [yy2, xx2, map] = size(out);
    yy = min([yy1 yy2]);
    xx = min([xx1 xx2]);

    bezImgRes = imresize(bezImg, [yy xx])./(max(max(bezImg)));
    outRes = imresize(out, [yy xx])./(max(max(bezImg)));

    img_diff = abs(bezImgRes - outRes);
    imshow(img_diff,[]);

    PorovnaniImg = img_diff;
end



% Aliasing artifact 
% --------------------------------------------------------------------
function tAliasing_Callback(hObject, eventdata, handles)
% hObject    handle to tAliasing (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function tARDetektory_Callback(hObject, eventdata, handles)
% hObject    handle to tARDetektory (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global inputImage;
global imgIsOpen;
global out;
global ArtefaktImg;
global PorovnaniImg;
global bezImg;
global setProjectors;
global setFilter;

in_dlg_title = 'Parametry aliasing artefaktu';
prompt{1} = 'Volba potu detektor: ';
parameters = inputdlg(prompt, in_dlg_title, [1 15], {'140' });

[ysize, xsize,map] = size(parameters);
if (ysize == 0) || (xsize == 0)
    return;
end

if imgIsOpen == 1
    [ysize, xsize,map] = size(inputImage);
    if map > 1
       i2 = double(rgb2gray(inputImage))./255;
    else
        i2 = inputImage;
    end
    out = aliasingDet(i2, str2double(parameters{1}), setProjectors, setFilter);
    
    [yImg, xImg, mImg] = size(out);
    if yImg > 0 && xImg > 0
        axes(handles.axes2)
        imshow(out, []);
        freezeColors;
        ArtefaktImg = out;

        if mImg > 1
            I = rgb2gray(out);
        else
           I = out;
        end
        
        axes(handles.axes3)
        [yy1, xx1, map] = size(inputImage);
        [yy2, xx2, map] = size(out);
        yy = min([yy1 yy2]);
        xx = min([xx1 xx2]);
        
        inputRes = imresize(i2, [yy xx])./(max(max(i2)));
        outRes = imresize(out, [yy xx])./(max(max(bezImg)));
        
        img_diff = abs(inputRes - outRes);
        imshow(img_diff,[]);

        PorovnaniImg = img_diff;
    end 
end

% --------------------------------------------------------------------
function tARProjekce_Callback(hObject, eventdata, handles)
% hObject    handle to tARProjekce (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


global inputImage;
global imgIsOpen;
global out;
global ArtefaktImg;
global PorovnaniImg;
global bezImg;
global setDetectors;
global setFilter;

in_dlg_title = 'Parametry aliasing artefaktu';
prompt{1} = 'Volba potu projekc ';
parameters = inputdlg(prompt, in_dlg_title, [1 15], {'45' });

[ysize, xsize,map] = size(parameters);
if (ysize == 0) || (xsize == 0)
    return;
end

if imgIsOpen == 1
    [ysize, xsize,map] = size(inputImage);
    if map > 1
       i2 = double(rgb2gray(inputImage))./255;
    else
        i2 = inputImage;
    end
    theta = linspace(0,179,str2double(parameters{1}));
    out = aliasingPro(i2, setDetectors, theta, setFilter);
    
    [yImg, xImg, mImg] = size(out);
    if yImg > 0 && xImg > 0
        axes(handles.axes2)
        imshow(out, []);
        freezeColors;
        ArtefaktImg = out;
   
        if mImg > 1
            I = rgb2gray(out);
        else
           I = out;
        end
        
        axes(handles.axes3)
        [yy1, xx1, map] = size(inputImage);
        [yy2, xx2, map] = size(out);
        yy = min([yy1 yy2]);
        xx = min([xx1 xx2]);
        
        inputRes = imresize(i2, [yy xx])./(max(max(i2)));
        outRes = imresize(out, [yy xx])./(max(max(bezImg)));
        
        img_diff = abs(inputRes - outRes);
        imshow(img_diff,[]);

        PorovnaniImg =img_diff;
    end 
end


%% metal artifact
% --------------------------------------------------------------------
function tKovovy_Callback(hObject, eventdata, handles)
% hObject    handle to tKovovy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global inputImage;
global imgIsOpen;
global out;
global ArtefaktImg;
global PorovnaniImg;

global bezImg;
global setDetectors;
global setProjectors;
global setFilter;

if imgIsOpen == 1
    [ysize, xsize,map] = size(inputImage);
    if map > 1
       i2 = double(rgb2gray(inputImage))./255;
    else
        i2 = inputImage;
    end
    [out, metalImg] = Metal(i2, setProjectors, setDetectors, setFilter);
    if out == -1
        return;
    end
    
    [tysize, txsize,tmap] = size(metalImg);
    tmpImg = imresize(bezImg, [tysize txsize]);
    for i=1:1:tysize
        for j=1:1:txsize
            tmpImgSum(i,j) = tmpImg(i,j) + metalImg(i,j);
            if tmpImgSum(i,j) > 1
                tmpImgSum(i,j) = 1;
            end
        end
    end
    [bezFwd, xp] = GetRadon(tmpImgSum, setProjectors, setDetectors);
    bezBwd = GetIRadon(bezFwd, setProjectors, setFilter);
    
    axes(handles.axes5)
    imshow(bezBwd./max(max(bezImg)));
    freezeColors;
    
    [yImg, xImg, mImg] = size(out);
    if yImg > 0 && xImg > 0
        axes(handles.axes2)
        imshow(out./max(max(bezImg)));
        freezeColors;
        ArtefaktImg = out;

        
        if mImg > 1
            I = rgb2gray(out);
        else
           I = out;
        end
        
        axes(handles.axes3)
        [yy1, xx1, map] = size(bezImg);
        [yy2, xx2, map] = size(out);
        yy = min([yy1 yy2]);
        xx = min([xx1 xx2]);
        
        bezImgRes = imresize(bezImg, [yy xx])./(max(max(bezImg)));
        outRes = imresize(out, [yy xx])./(max(max(bezImg)));
        
        img_diff = abs(bezImgRes - outRes);
         imshow(img_diff,[]);

        PorovnaniImg = img_diff;
    end 
end

%% streak artifact
% --------------------------------------------------------------------
function tKvantovy_Callback(hObject, eventdata, handles)
% hObject    handle to tKvantovy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global inputImage;
global imgIsOpen;
global out;
global ArtefaktImg;
global PorovnaniImg;

global bezImg;

global setDetectors;
global setProjectors;
global setFilter;

if imgIsOpen == 1
    [ysize, xsize,map] = size(inputImage);
    if map > 1
       i2 = double(rgb2gray(inputImage))./255;
    else
        i2 = inputImage;
    end
    out = Streak(i2, setProjectors, setDetectors, setFilter);
    
    if out == -1
       return; 
    end
     
    [yImg, xImg, mImg] = size(out);
    if yImg > 0 && xImg > 0
        axes(handles.axes2)
        imshow(out./max(max(bezImg)));
        freezeColors;
        ArtefaktImg = out;
  
        if mImg > 1
            I = rgb2gray(out);
        else
           I = out;
        end
        
        axes(handles.axes3)
        [yy1, xx1, map] = size(bezImg);
        [yy2, xx2, map] = size(out);
        yy = min([yy1 yy2]);
        xx = min([xx1 xx2]);
        
        bezImgRes = imresize(bezImg, [yy xx])./(max(max(bezImg)));
        outRes = imresize(out, [yy xx])./(max(max(bezImg)));
        
        img_diff = abs(bezImgRes - outRes);
        imshow(img_diff,[]);

        PorovnaniImg = img_diff;
    end 
end


%% zobrazovani menu
% --------------------------------------------------------------------
function tView_Callback(hObject, eventdata, handles)
% hObject    handle to tView (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function tv2dradon_Callback(hObject, eventdata, handles)
% hObject    handle to tv2dradon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function tv3dradon_Callback(hObject, eventdata, handles)
% hObject    handle to tv3dradon (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function tvSlice_Callback(hObject, eventdata, handles)
% hObject    handle to tvSlice (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%% zobrazovani 2D
% --------------------------------------------------------------------
function tvstupni_obraz2D_Callback(hObject, eventdata, handles)
% hObject    handle to tvstupni_obraz2D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global bezImg;

if bezImg ~= 0
    show2DRadon(bezImg);
end

% --------------------------------------------------------------------
function tartefakt2D_Callback(hObject, eventdata, handles)
% hObject    handle to tartefakt2D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global ArtefaktImg;

if ArtefaktImg ~= 0
    show2DRadon(ArtefaktImg);
end

% --------------------------------------------------------------------
function tporovnani2D_Callback(hObject, eventdata, handles)
% hObject    handle to tporovnani2D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global PorovnaniImg;

if PorovnaniImg ~= 0
    show2DRadon(PorovnaniImg);
end

%% zobrazovani 3D
% --------------------------------------------------------------------
function tvstupni_obraz3D_Callback(hObject, eventdata, handles)
% hObject    handle to tvstupni_obraz3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global bezImg;

if bezImg ~= 0
    show3DRadon(bezImg);
end

% --------------------------------------------------------------------
function tartefakt3D_Callback(hObject, eventdata, handles)
% hObject    handle to tartefakt3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global ArtefaktImg;

if ArtefaktImg ~= 0
    show3DRadon(ArtefaktImg);
end

% --------------------------------------------------------------------
function tporovnani3D_Callback(hObject, eventdata, handles)
% hObject    handle to tporovnani3D (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global PorovnaniImg;

if PorovnaniImg ~= 0
    show3DRadon(PorovnaniImg);
end

%% zobrazovani slice
% --------------------------------------------------------------------
function tvstupni_obrazRez_Callback(hObject, eventdata, handles)
% hObject    handle to tvstupni_obrazRez (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
in_dlg_title = 'Volba ezu v projekci';
prompt{1} = 'ez v dan projekci: ';
parameters = inputdlg(prompt, in_dlg_title, [1 15], {'5'});

[yPar, xPar, mPar] = size(parameters);
if yPar == 0 || xPar == 0
    return;
end

global bezImg;

if bezImg ~= 0
    showSlice(bezImg, str2double(parameters{1}));
end


% --------------------------------------------------------------------
function tartefaktRez_Callback(hObject, eventdata, handles)
% hObject    handle to tartefaktRez (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
in_dlg_title = 'Volba ezu v projekci';
prompt{1} = 'ez v dan projekci: ';
parameters = inputdlg(prompt, in_dlg_title, [1 15], {'5'});

[yPar, xPar, mPar] = size(parameters);
if yPar == 0 || xPar == 0
    return;
end

global ArtefaktImg;

if ArtefaktImg ~= 0
    showSlice(ArtefaktImg, str2double(parameters{1}));
end

% --------------------------------------------------------------------
function tporovnaniRez_Callback(hObject, eventdata, handles)
% hObject    handle to tporovnaniRez (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
in_dlg_title = 'Volba ezu v projekci';
prompt{1} = 'ez v dan projekci: ';
parameters = inputdlg(prompt, in_dlg_title, [1 15], {'5'});

[yPar, xPar, mPar] = size(parameters);
if yPar == 0 || xPar == 0
    return;
end

global PorovnaniImg;

if PorovnaniImg ~= 0
    showSlice(PorovnaniImg, str2double(parameters{1}));
end

%% zobrazovaci funkce
function show2DRadon(img)

[yImg, xImg, mImg] = size(img);
if yImg > 0 && xImg > 0
    figure;

    if mImg > 1
        I = rgb2gray(img);
    else
       I = img;
    end

    theta = 0:180;
    [R, xp] = radon(I ,theta);
    imagesc(theta,xp,R);

    xlabel('\theta (degrees)')
    ylabel('X\prime');
    colormap(hot)
    iptsetpref('ImshowAxesVisible','off')
end    

function show3DRadon(img)
[yImg, xImg, mImg] = size(img);
if yImg > 0 && xImg > 0
    figure;

    if mImg > 1
        I = rgb2gray(img);
    else
       I = img;
    end

    theta = 0:180;
    [R, xp] = radon(I ,theta);
    iptsetpref('ImshowAxesVisible','on')

    surf(R);
    xlabel('\theta (degrees)')
    ylabel('X\prime');
    colormap(hot)
    iptsetpref('ImshowAxesVisible','off')

end 

function showSlice(img, slice)
[yImg, xImg, mImg] = size(img);
if yImg > 0 && xImg > 0
    figure;

    if mImg > 1
        I = rgb2gray(img);
    else
       I = img;
    end

    theta = 0:180;
    [R, xp] = radon(I ,theta);
    iptsetpref('ImshowAxesVisible','on')

    plot(R(:, slice));
    grid on;
    xlabel('X\prime');
    colormap(hot)
    iptsetpref('ImshowAxesVisible','off')

end
